mod gemdir;

use gemdir::{visit_dirs, writefeed, Gemdir};
use std::{env, io, path::Path};

#[macro_use()]
extern crate log;

fn buildsite(
    dir: &Path,
    g: &mut Gemdir,
    title: String,
    url: String,
    author: String,
) -> io::Result<()> {
    g.changeroot(dir);
    g.refactorindex();

    g.writetodisk()?;
    writefeed(g, title, url, author)
}

fn main() {
    env_logger::init();

    let args: Vec<String> = env::args().collect();
    // let dir = Path::new("/home/raphy/Documents/Projects/Rust/rugem/testsite/");
    let dir = Path::new(&args[1]);
    let dst = Path::new(&args[2]);
    let title = &args[3];
    let url = &args[4];
    let auth = &args[5];
    let mut k = visit_dirs(&dir).unwrap();

    buildsite(
        dst,
        &mut k,
        title.to_string(),
        url.to_string(),
        auth.to_string(),
    );
    // print!("{:?}", k)
}
